<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Task 23B.60 Lucky Dice Casion subtask5 sửa and đẩy lên merge 5</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .picture-cover {
        background-image: url(LuckyDiceImages/cover.jpg);
        min-height: 100px;
        margin: 5px;
    }
</style>

<body>
    <div class="container-fluid success picture-cover">

    </div>
    <div class="container bg">
        <div class="row success">
            <div class="col-5 white  -success">
                <div class="row  -">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row  -success">
                    <div class="col-4  -success">
                        <label>Username</label>
                    </div>
                    <div class="col-8  -success">
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row  ">

                    <div class="col-4  ">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row  ">
                    <div class="col-4  ">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  -v">
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center">
                <div class="row">
                    <div class="col-12  ">
                        <input onclick="onBtnNemClick()" id="btn-dice" class="btn btn-success button-width w-75"
                            value="ném" type="button">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12  ">
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/diceRound.gif">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12  ">
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>

            </div>
            <div class="col-3  text-center">
                <div class="row form-group">
                    <div class="col-12  ">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No Id</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12  ">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/xe-may.jpg">
                    </div>
                </div>
            </div>
        </div>

        <div class="row bg text-center">
            <div class="col-12">
                <button id="btn-dice-history"  onclick="onBtnClickDiceHistoryClick()" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>

            </div>
        </div>
        <div class="row bg">
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <thead>
                    <tr>
                        <th>lượt</th>
                        <th>Dice</th>
                    </tr>
                </thead>
                <tbody>
          
                </tbody>
                </table>
            </div>
        </div>
    </div>

</body>
<script>
    // biến toàn cục

    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    var gUser = {
        username: "",
        firstname: "",
        lastname: "",
    }


    function onBtnNemClick() {
        thuThapDuLieu(gUser)
        var vDuLieuHopLe = kiemTraDuLieu(gUser);
        if (vDuLieuHopLe) {
            var vXMLHttpDice = new XMLHttpRequest();
            callApiSeverDice(vXMLHttpDice, gUser);
            vXMLHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    processReponse(vXMLHttpDice);
                }
            }
        }
    }

    // thu thập dữ liệu
    function thuThapDuLieu(paramUser) {
        var vUserName = document.getElementById("inp-user-name");
        var vFirstName = document.getElementById("inp-first-name");
        var vLastName = document.getElementById("inp-last-name");

        paramUser.username = vUserName.value.trim();
        paramUser.firstname = vFirstName.value.trim();
        paramUser.lastname = vLastName.value.trim();
    }
    // kiểm tra dữ liệu
    function kiemTraDuLieu(paramUser) {
        if (paramUser.username == "") {
            alert("bạn cần nhập username")
            return false;
        }
        if (paramUser.firstname == "") {
            alert("bạn cần nhập firstname")
            return false;
        }
        if (paramUser.lastname == "") {
            alert("bạn cần nhập lastname")
            return false;
        }
        return true;
    }
    // gọi API 
    function callApiSeverDice(paramXmlHtmlDice, paramDataUser) {
        paramXmlHtmlDice.open("POST", vBASE_URL + "/dice", true);
        paramXmlHtmlDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHtmlDice.send(JSON.stringify(paramDataUser));
    }
    // xử lý response trả về thành công
    function processReponse(paramXmlHtmlDice) {
        console.log(paramXmlHtmlDice.responseText);
        var vResponseToObject = JSON.parse(paramXmlHtmlDice.responseText)
        console.log(vResponseToObject);
        var vDiceReady = vResponseToObject.dice;
        console.log("dice result:=" + vDiceReady);
        // hàm đổi hình
        changeDice(vDiceReady);
        // hàm đổi lời nhắn
        changeNotification(vDiceReady)
        // hàm hiển thị voucher
        changVoucherId(vResponseToObject);
        // hàm chuyển hình ảnh
        changeGifl(vResponseToObject)
    }
    // đổi hình xúc xắc
    function changeDice(paramDice) {
        var vImgDice = document.getElementById("img-dice");
        switch (paramDice) {
            case 1:
                vImgDice.src = "LuckyDiceImages/1.png"
                break;
            case 2:  
                vImgDice.src = "LuckyDiceImages/2.png"
                break; 
            case 3:
                vImgDice.src = "LuckyDiceImages/3.png"
                break;
            case 4:  
                vImgDice.src = "LuckyDiceImages/4.png"
                break;      
            case 5:
                vImgDice.src = "LuckyDiceImages/5.png"
                break;
             case 6:  
                vImgDice.src = "LuckyDiceImages/6.png"
                break;             
        }
    }
    // đổi p hiển thị
    function changeNotification(paramDice){
        var vPNotification = document.getElementById("p-notification-dice")
        if(paramDice < 4){
            vPNotification.innerHTML = ("Chúc bạn may mắn lần sau nha!");
        }else{
            vPNotification.innerHTML = ("chúc mừng bạn hãy chơi tiếp lần nữa!");
        }
    }
    // hàm hiển thị voucher
    function changVoucherId(paramResponeVoucher){
        var vPVoucherId = document.getElementById("p-voucher-id");
        var vPVoucherPercent = document.getElementById("p-voucher-percent");

        if(paramResponeVoucher.voucher != null){
            vPVoucherId.innerHTML = paramResponeVoucher.voucher.maVoucher;
            vPVoucherPercent.innerHTML = paramResponeVoucher.voucher.phanTramGiamGia + "%";

        }else{
            vPVoucherId.innerHTML = "";
            vPVoucherPercent.innerHTML =  "";
        }
    };
    // hàm chuyển hình ảnh 
    function changeGifl(paramResponePrize){
        var vImgPresent = document.getElementById("img-present");
        var vTenPhanThuong = paramResponePrize.prize;
        switch(vTenPhanThuong){
           
            case "Xe đạp":
                vImgPresent.src ="LuckyDiceImages/bike.jpg"
                break;  
            case "Xe máy":
                vImgPresent.src ="LuckyDiceImages/xe-may.jpg"
                break;     
            case "Ô tô":
                vImgPresent.src ="LuckyDiceImages/car.jpg"
                break;     
            default:
                vImgPresent.src =  "LuckyDiceImages/no-present.jpg"          
        }

    }

    //gọi mẫu lấy dic history
    function onBtnClickDiceHistoryClick() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        var vUserNameTest = gUser.username;
        
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        vXmlHttpDiceHistory.open("GET", vBASE_URL + "/dice-history?username=" + gUser.username, true);
        vXmlHttpDiceHistory.send();
        vXmlHttpDiceHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpDiceHistory.responseText);
                    hienThiLichSuLenTable(vXmlHttpDiceHistory);
                }
            }
    }

    // hiện thị thông tin lên bản
    function hienThiLichSuLenTable(paramXmlHttpObj){
      console.log(paramXmlHttpObj.responseText);
      var vDiceHistoryObj = JSON.parse(paramXmlHttpObj.responseText)
      var vDiceHistoryDiceTable = document.getElementById("history-placeholder-table");
      var vTbodyDiceHistory = vDiceHistoryDiceTable.getElementsByTagName("tbody")[0];
     // xóa trắng dữ liệu trong bảng
      vTbodyDiceHistory.innerHTML="";
      for( var bI = 0; bI < vDiceHistoryObj.dices.length; bI++){
        var bNewRow = vTbodyDiceHistory.insertRow(gEND_OF_ROW_COL);
        var bLuotNem = bNewRow.insertCell(0);
        var bDice = bNewRow.insertCell(1);
        
        bLuotNem.innerHTML = bI + 1;
        bDice.innerHTML = vDiceHistoryObj.dices[bI];
        
      }
    }
</script>

</html>